KERNEL_IMG_NAME := .vmlinux

START_SCRIPT_CAPI := $(FILESYSTEM)/etc/init.d/E41-capi
START_SCRIPT_PIGLET := $(FILESYSTEM)/etc/init.d/S11-piglet

define filechk_lha_options
	(set -e; \
	grep '[TA] _text' $< | sed -e's/\(.*\) [TA] .*/-l 0x\1/g' | tr -d '\n'; \
	echo -n ' '; \
	grep 'T kernel_entry' $< | sed -e's/\(.*\) T .*/-e 0x\1/g' | tr -d '\n' \
	) <$<
endef

.lha.options: $(FILESYSTEM)/System.map force
	$(call filechk,lha_options)

$(FILESYSTEM)/$(KERNEL_IMG_NAME): $(LINUX_KERNEL_BUILDDIR)/vmlinux
	@echo "  OBJCOPY $(notdir $<) -> $@"
	$(CROSS_COMPILE)objcopy --remove-section .note.gnu.build-id -S -O binary $< $@
	# fuer dissassemble-helper in avmterm:
	echo `nm $< | grep "kallsyms_\(names\|token\|num_syms\|addresses\)"` >> $@
	echo `file -b -e elf $<` >>$@

dtbs = $(wildcard $(LINUX_KERNEL_BUILDDIR)/arch/$(ARCH)/boot/dts/Fritz_Box_*.dtb)
install: install_dtbs
install_dtbs: $(dtbs)
ifeq ($(dtbs),)
	$(error No device-tree blobs found!  Is CONFIG_OF_AVM_DT set?)
endif
	@echo "  INSTALL generated device tree blobs"
	$(foreach dtb,$(dtbs),$(call cmd_install,$(dtb),$(FILESYSTEM)/avm_dts/))

# vim: set ft=make noexpandtab ts=8:
